=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://lemon.cs.elte.hu/trac/lemon/wiki/Downloads .*/sources/lemon-(\d[.\d]+)\.tar\.gz
