=== debian/changelog ===
liblemon (1.3.1+dfsg-7) unstable; urgency=medium

  * Team upload.
  * d/watch: convert to watch file version 5.
  * cmake-4.patch: new: bump minimum cmake to 3.10. (Closes: #1113170)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/patches/*: normalize dep3 header.

 -- Étienne Mollier <emollier@debian.org>  Thu, 02 Oct 2025 21:11:32 +0200

liblemon (1.3.1+dfsg-6) unstable; urgency=medium

  * Fix pkg-config --libs response
    Closes: #1015955
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 25 Jul 2022 20:36:57 +0200

liblemon (1.3.1+dfsg-5) unstable; urgency=medium

  * Versioned Build-Depends: d-shlibs (>= 0.80)
  * Drop needless overrides d-shlibs for libglpk
    Closes: #999843
  * Enable dh_missing --fail-missing
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 17 Nov 2021 18:57:16 +0100

liblemon (1.3.1+dfsg-4) unstable; urgency=medium

  * Build-Depends: s/python/python3/
    Closes: #967164

 -- Andreas Tille <tille@debian.org>  Wed, 05 Aug 2020 10:37:12 +0200

liblemon (1.3.1+dfsg-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Drop workaround for jquery.js which is not used any more
  * Secure URI in watch file
  * debhelper-compat 13
  * Standards-Version: 4.5.0
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/rules
  * Use secure URI in Homepage field.
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Do not install lemon-0.x-to-1.x.sh

  [ zhao feng ]
  * filter out failed test
  * fix ctest path
    Closes: #925749

 -- Andreas Tille <tille@debian.org>  Tue, 07 Jul 2020 10:47:54 +0200

liblemon (1.3.1+dfsg-2) unstable; urgency=medium

  [ Ryan Pavlik ]
  * Modify CMake config file to support multiarch
  * Cherry-pick selected upstream changes on the 1.3 branch

  [ Andreas Tille ]
  * Specify copyright of lemon/random.h
  * Fix homepage in d/control and download in d/watch
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.0

 -- Andreas Tille <tille@debian.org>  Wed, 22 Aug 2018 16:26:20 +0200

liblemon (1.3.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #833548)

 -- Andreas Tille <tille@debian.org>  Fri, 05 Aug 2016 22:29:07 +0200
