=== debian/control ===
Source: liblemon
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               libglpk-dev,
               python3,
               doxygen,
               graphviz,
               libjs-mathjax,
               ghostscript
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/liblemon
Vcs-Git: https://salsa.debian.org/med-team/liblemon.git
Homepage: https://lemon.cs.elte.hu/trac/lemon

Package: liblemon1.3.1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: Library for Efficient Modeling and Optimization in Networks
 LEMON stands for Library for Efficient Modeling and Optimization in
 Networks. It is a C++ template library providing efficient
 implementations of common data structures and algorithms with focus
 on combinatorial optimization tasks connected mainly with graphs
 and networks.
 .
 LEMON is a member of the COIN-OR initiative, a collection of OR related
 open source projects.
 .
 This package contains the dynamic library.

Package: liblemon-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         liblemon1.3.1 (= ${binary:Version})
Description: Library for Efficient Modeling and Optimization in Networks (development)
 LEMON stands for Library for Efficient Modeling and Optimization in
 Networks. It is a C++ template library providing efficient
 implementations of common data structures and algorithms with focus
 on combinatorial optimization tasks connected mainly with graphs
 and networks.
 .
 LEMON is a member of the COIN-OR initiative, a collection of OR related
 open source projects.
 .
 This package contains the static library and header files.

Package: liblemon-utils
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Library for Efficient Modeling and Optimization in Networks (utilities)
 LEMON stands for Library for Efficient Modeling and Optimization in
 Networks. It is a C++ template library providing efficient
 implementations of common data structures and algorithms with focus
 on combinatorial optimization tasks connected mainly with graphs
 and networks.
 .
 LEMON is a member of the COIN-OR initiative, a collection of OR related
 open source projects.
 .
 This package contains the utilities accompanying the library.

Package: liblemon-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Library for Efficient Modeling and Optimization in Networks (doc)
 LEMON stands for Library for Efficient Modeling and Optimization in
 Networks. It is a C++ template library providing efficient
 implementations of common data structures and algorithms with focus
 on combinatorial optimization tasks connected mainly with graphs
 and networks.
 .
 LEMON is a member of the COIN-OR initiative, a collection of OR related
 open source projects.
 .
 This package contains the library documentation.
