=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

CMAKE_EXTRA_FLAGS += -DBUILD_SHARED_LIBS=TRUE -DLEMON_DOC_USE_MATHJAX=YES

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	cd obj-*/doc && make html

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-* && make check
	cd obj-* && ctest -E lgf_reader_writer_test
endif

override_dh_install:
	dh_install
	cp -a obj-*/lemon/liblemon_static.a debian/tmp/usr/lib/liblemon.a
	# rename cmake config file
	mv debian/tmp/usr/share/lemon/cmake/LEMONConfig.cmake debian/tmp/usr/share/lemon/cmake/lemonConfig.cmake
	# Modify CMake config file to add multiarch
	sed -i 's:usr/lib:usr/lib/$(DEB_HOST_MULTIARCH):' debian/tmp/usr/share/lemon/cmake/*
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
                    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    --movedev "debian/tmp/usr/lib/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    --movedev "debian/tmp/usr/share/lemon/cmake/*" usr/lib/$(DEB_HOST_MULTIARCH)/cmake/lemon \
                    debian/tmp/usr/lib/*.so
        # dh_missing stumbles upon this file
	find debian -name lemon-0.x-to-1.x.sh -delete
	find debian -name "lib*.la" -delete

override_dh_installchangelogs:
	dh_installchangelogs NEWS
