=== debian/watch ===
Version: 5

Source: https://lemon.cs.elte.hu/trac/lemon/wiki/Downloads
Matching-Pattern: .*/sources/lemon-(\d[.\d]+)\.tar\.gz
Compression: xz
Dversionmangle: s/\+dfsg//g
Repack: yes
Repacksuffix: +dfsg
